//
//	Code generated by LayoutCode
//	www.layoutcodeapp.com
//

import UIKit

class CameraCell: UICollectionViewCell {
	// MARK: Derived Properties
	
	public var cameraImage: UIImage!{
		get{
			return placeholderImageView.image
		}
		set{
			placeholderImageView.image = newValue
		}
	}
	public var lastUpdatedDuration: String!{
		get{
			return lastUpdateLabel.text
		}
		set{
			lastUpdateLabel.text = newValue
		}
	}
	public var hideNoResponse: Bool!{
		get{
			return noResponseView.isHidden
		}
		set{
			noResponseView.isHidden = newValue
		}
	}
	
	// MARK: Properties
	
	var placeholderImageView : UIImageView = {
		var imageView = UIImageView()
		imageView.frame = CGRect(x: 2.58e-05, y: -2.75e-05, width: 180, height: 187)
		imageView.isHidden = false
		imageView.clipsToBounds = false
		imageView.contentMode = .scaleToFill
		imageView.image = UIImage(named: "cameraView-placeholderImage.jpg")!
		return imageView
	}()
	var lastUpdateLabel : UILabel = {
		var text = UILabel()
		text.frame = CGRect(x: 5, y: 157, width: 37.5, height: 19)
		text.isHidden = false
		text.text = "10s"
		text.numberOfLines = 1
		text.textAlignment = .center
		text.font = UIFont(name: ".AppleSystemUIFontMedium", size: 15)
		text.textColor = UIColor.white
		return text
	}()
	var noResponseView : NoResponseView = {
		var noResponseView = NoResponseView()
		noResponseView.frame = CGRect(x: 2.15e-05, y: -2.7e-05, width: 181, height: 187)
		noResponseView.isHidden = true
		return noResponseView
	}()
	
	// MARK: Setup
	
	override init(frame: CGRect) {
		super.init(frame: frame)
		setup()
	}
	
	required init?(coder aDecoder: NSCoder)
	{
		super.init(coder: aDecoder)
		setup()
	}
	
	func setup(){
		layer.cornerRadius = 5
		clipsToBounds = true
		backgroundColor = UIColor.clear.withAlphaComponent(0)
		cameraImage = UIImage(named: "cameraView-placeholderImage.jpg")!
		lastUpdatedDuration = "10s"
		hideNoResponse = true
		isHidden = false
		
		addSubview(placeholderImageView)
		addSubview(lastUpdateLabel)
		addSubview(noResponseView)
		
		placeholderImageView.translatesAutoresizingMaskIntoConstraints = false
		lastUpdateLabel.translatesAutoresizingMaskIntoConstraints = false
		noResponseView.translatesAutoresizingMaskIntoConstraints = false
		
		setupConstraints()
		setupGradientObserver()
	}
	
	private var gradientObservers = [String: NSKeyValueObservation]()
	func setupGradientObserver(){
		gradientObservers["noResponseView"] = noResponseView.observe(\.bounds) { (view, change) in
			view.gradientLayer()?.frame = view.bounds
		}
		
	}
	
	func setupConstraints(){
		NSLayoutConstraint.activate([
			placeholderImageView.leadingAnchor.constraint(equalTo: leadingAnchor, constant: 0),
			placeholderImageView.trailingAnchor.constraint(equalTo: trailingAnchor, constant: -1),
			placeholderImageView.topAnchor.constraint(equalTo: topAnchor, constant: 0),
			placeholderImageView.bottomAnchor.constraint(equalTo: bottomAnchor, constant: 0),
		
		])
		NSLayoutConstraint.activate([
			lastUpdateLabel.leadingAnchor.constraint(equalTo: leadingAnchor, constant: 5),
			lastUpdateLabel.bottomAnchor.constraint(equalTo: bottomAnchor, constant: -10),
		
		])
		NSLayoutConstraint.activate([
			noResponseView.leadingAnchor.constraint(equalTo: leadingAnchor, constant: 0),
			noResponseView.trailingAnchor.constraint(equalTo: placeholderImageView.trailingAnchor, constant: 0),
			noResponseView.topAnchor.constraint(equalTo: topAnchor, constant: 0),
			noResponseView.bottomAnchor.constraint(equalTo: bottomAnchor, constant: 0),
		
		])
		
	}
}
