//
//	Code generated by LayoutCode
//	www.layoutcodeapp.com
//

import UIKit

class FavouriteDeviceCell: UICollectionViewCell {
	// MARK: Derived Properties
	
	public var roomText: String!{
		get{
			return roomLabel.text
		}
		set{
			roomLabel.text = newValue
		}
	}
	public var accessoryName: String!{
		get{
			return accessoryLabel.text
		}
		set{
			accessoryLabel.text = newValue
		}
	}
	public var statusText: String!{
		get{
			return statusLabel.text
		}
		set{
			statusLabel.text = newValue
		}
	}
	public var accessoryImage: UIImage!{
		get{
			return accessoryImageView.image
		}
		set{
			accessoryImageView.image = newValue
		}
	}
	
	// MARK: Properties
	
	var basic2 : UIView = {
		var view = UIView()
		view.frame = CGRect(x: 3.21e-06, y: -1.26e-05, width: 195, height: 105)
		view.layer.cornerRadius = 15
		view.isHidden = false
		view.clipsToBounds = false
		view.backgroundColor = UIColor.black.withAlphaComponent(0.2)
		return view
	}()
	var statusLabel : UILabel = {
		var text = UILabel()
		text.frame = CGRect(x: 58, y: 34.5, width: 28.5, height: 16)
		text.isHidden = false
		text.text = "Off"
		text.numberOfLines = 1
		text.textAlignment = .left
		text.font = UIFont(name: ".AppleSystemUIFont", size: 13)
		text.textColor = UIColor.white.withAlphaComponent(0.6)
		return text
	}()
	var roomLabel : UILabel = {
		var text = UILabel()
		text.frame = CGRect(x: 58, y: 2.47, width: 83.5, height: 16)
		text.isHidden = false
		text.text = "Living Room"
		text.numberOfLines = 1
		text.textAlignment = .left
		text.font = UIFont(name: ".AppleSystemUIFont", size: 13)
		text.textColor = UIColor.white.withAlphaComponent(0.8)
		return text
	}()
	var accessoryImageView : UIImageView = {
		var imageView = UIImageView()
		imageView.frame = CGRect(x: 16, y: 37.5, width: 30, height: 30)
		imageView.isHidden = false
		imageView.clipsToBounds = false
		imageView.contentMode = .scaleToFill
		imageView.image = UIImage(named: "favouriteDeviceView-accessoryImage.jpg")!
		return imageView
	}()
	var accessoryLabel : UILabel = {
		var text = UILabel()
		text.frame = CGRect(x: 58, y: 16.5, width: 75, height: 16)
		text.isHidden = false
		text.text = "Right Light"
		text.numberOfLines = 1
		text.textAlignment = .left
		text.font = UIFont(name: ".AppleSystemUIFont", size: 13)
		text.textColor = UIColor.white
		return text
	}()
	
	// MARK: Setup
	
	override init(frame: CGRect) {
		super.init(frame: frame)
		setup()
	}
	
	required init?(coder aDecoder: NSCoder)
	{
		super.init(coder: aDecoder)
		setup()
	}
	
	func setup(){
		clipsToBounds = false
		backgroundColor = UIColor.clear.withAlphaComponent(0)
		roomText = "Living Room"
		accessoryName = "Right Light"
		statusText = "Off"
		accessoryImage = UIImage(named: "favouriteDeviceView-accessoryImage.jpg")!
		isHidden = false
		
		addSubview(basic2)
		addSubview(statusLabel)
		addSubview(roomLabel)
		addSubview(accessoryImageView)
		addSubview(accessoryLabel)
		
		basic2.translatesAutoresizingMaskIntoConstraints = false
		statusLabel.translatesAutoresizingMaskIntoConstraints = false
		roomLabel.translatesAutoresizingMaskIntoConstraints = false
		accessoryImageView.translatesAutoresizingMaskIntoConstraints = false
		accessoryLabel.translatesAutoresizingMaskIntoConstraints = false
		
		setupConstraints()
		setupGradientObserver()
	}
	
	private var gradientObservers = [String: NSKeyValueObservation]()
	func setupGradientObserver(){
		gradientObservers["basic2"] = basic2.observe(\.bounds) { (view, change) in
			view.gradientLayer()?.frame = view.bounds
		}
		
	}
	
	func setupConstraints(){
		NSLayoutConstraint.activate([
			basic2.leadingAnchor.constraint(equalTo: leadingAnchor, constant: 0),
			basic2.trailingAnchor.constraint(equalTo: trailingAnchor, constant: -1),
			basic2.topAnchor.constraint(equalTo: topAnchor, constant: 0),
			basic2.bottomAnchor.constraint(equalTo: bottomAnchor, constant: 0),
		
		])
		NSLayoutConstraint.activate([
			statusLabel.leadingAnchor.constraint(equalTo: roomLabel.leadingAnchor, constant: 0),
			statusLabel.topAnchor.constraint(equalTo: accessoryLabel.bottomAnchor, constant: 2),
		
		])
		NSLayoutConstraint.activate([
			roomLabel.leftAnchor.constraint(equalTo: accessoryImageView.rightAnchor, constant: 12),
			roomLabel.bottomAnchor.constraint(equalTo: accessoryLabel.topAnchor, constant: -2),
			roomLabel.leadingAnchor.constraint(equalTo: accessoryLabel.leadingAnchor, constant: 0),
		
		])
		NSLayoutConstraint.activate([
			accessoryImageView.widthAnchor.constraint(equalToConstant: 30),
			accessoryImageView.heightAnchor.constraint(equalToConstant: 30),
			accessoryImageView.leadingAnchor.constraint(equalTo: leadingAnchor, constant: 16),
			accessoryImageView.centerYAnchor.constraint(equalTo: centerYAnchor, constant: 0),
		
		])
		NSLayoutConstraint.activate([
			accessoryLabel.centerYAnchor.constraint(equalTo: accessoryImageView.centerYAnchor, constant: 0),
		
		])
		
	}
}
